;; mlang-tab.scm

;; Copyright 2015-2018 Matthew R. Wette
;; 
;; This library is free software; you can redistribute it and/or
;; modify it under the terms of the GNU Lesser General Public
;; License as published by the Free Software Foundation; either
;; version 3 of the License, or (at your option) any later version.
;; See the file COPYING included with the this distribution.

(define mlang-mtab
  '(($start . 107) ($lone-comm . 3) ($string . 4) ($float . 5) ($fixed . 6) 
    ($ident . 7) (";" . 8) ("." . 9) (".'" . 10) ("'" . 11) ("~" . 12) 
    (".^" . 13) (".\\" . 14) ("./" . 15) (".*" . 16) ("^" . 17) ("\\" . 18) 
    ("/" . 19) ("*" . 20) (".-" . 21) (".+" . 22) ("-" . 23) ("+" . 24) 
    (">=" . 25) ("<=" . 26) (">" . 27) ("<" . 28) ("~=" . 29) ("==" . 30) 
    ("&" . 31) ("|" . 32) (":" . 33) ("}" . 34) ("{" . 35) ("case" . 36) 
    ("elseif" . 37) ("load" . 38) ("global" . 39) ("clear" . 40) ("return" . 
    41) ("otherwise" . 42) ("switch" . 43) ("else" . 44) ("if" . 45) ("while" 
    . 46) ("for" . 47) ("\n" . 48) ("," . 49) (")" . 50) ("(" . 51) ("=" . 52)
    ("]" . 53) ("[" . 54) ("function" . 55) ("end" . 56) ($error . 2) ($end . 
    58)))

(define mlang-ntab
  '((59 . float) (60 . lone-comment-list-1) (61 . term-list) (62 . nl) 
    (63 . row-term) (64 . matrix-row) (65 . matrix-row-list) (66 . number) 
    (67 . primary-expr) (68 . postfix-expr) (69 . unary-expr) (70 . mul-expr) 
    (71 . add-expr) (72 . rel-expr) (73 . equality-expr) (74 . and-expr) 
    (75 . or-expr) (76 . expr-list) (77 . string-list) (78 . fixed-list) 
    (79 . string) (80 . fixed) (81 . case-expr) (82 . arg-list) (83 . command)
    (84 . case-list) (85 . elseif-list) (86 . expr) (87 . 
    nontrivial-statement-1) (88 . lone-comment) (89 . trivial-statement) 
    (90 . triv-stmt-list-1) (91 . ident) (92 . ident-list) (93 . 
    lone-comment-list) (94 . function-decl-line) (95 . term) (96 . the-end) 
    (97 . stmt-list) (98 . non-comment-statement) (99 . function-decl) 
    (100 . statement) (101 . mlang-item) (102 . mlang-item-list-1) (103 . 
    function-defn) (104 . mlang-item-list) (105 . nontrivial-statement) 
    (106 . triv-stmt-list) (107 . translation-unit)))

(define mlang-len-v
  #(1 3 3 2 2 1 0 2 1 1 4 3 2 2 2 1 10 9 8 7 6 5 1 3 1 2 1 1 2 1 1 1 1 2 1 2 
    1 3 7 5 8 6 7 5 8 5 1 2 1 1 1 1 2 4 5 0 5 1 1 3 3 1 2 1 2 1 3 1 1 3 5 3 5 
    1 3 1 3 1 3 3 1 3 3 3 3 1 3 3 3 3 1 3 3 3 3 3 3 3 3 1 2 2 2 1 2 2 4 3 3 1 
    1 1 3 2 3 2 3 1 3 1 1 1 3 1 2 1 1 1 1 2 3 1 1 1 1 1 1 1 1))

(define mlang-rto-v
  #(#f 107 107 107 107 104 102 102 101 101 103 103 103 96 99 99 94 94 94 94 
    94 94 92 92 97 97 106 90 90 100 100 98 98 89 89 105 87 87 87 87 87 87 87 
    87 87 87 87 87 83 83 83 82 82 85 85 84 84 81 81 81 81 78 78 77 77 76 76 86
    86 86 86 86 86 75 75 74 74 73 73 73 72 72 72 72 72 71 71 71 71 71 70 70 70
    70 70 70 70 70 70 69 69 69 69 68 68 68 68 68 68 67 67 67 67 67 67 67 67 65
    65 63 63 64 64 61 61 95 95 95 93 60 60 91 80 59 66 66 79 88 62))

(define mlang-pat-v
  #(((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) 
    (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) 
    (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) (48 . 22) 
    (73 . 23) (3 . 24) (49 . 25) (8 . 26) (62 . 27) (74 . 28) (33 . 29) 
    (75 . 30) (38 . 31) (39 . 32) (40 . 33) (95 . 34) (88 . 35) (55 . 36) 
    (83 . 37) (41 . 38) (43 . 39) (45 . 40) (46 . 41) (47 . 42) (86 . 43) 
    (89 . 44) (94 . 45) (87 . 46) (90 . 47) (99 . 48) (103 . 49) (105 . 50) 
    (106 . 51) (107 . 52)) ((1 . -133)) ((1 . -132)) ((1 . -136)) ((1 . -135))
    ((1 . -134)) ((1 . -131)) ((34 . 111) (5 . 1) (6 . 2) (4 . 3) (59 . 4) 
    (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) 
    (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) 
    (71 . 20) (72 . 21) (73 . 23) (74 . 28) (33 . 29) (75 . 30) (86 . 108) 
    (64 . 109) (65 . 112)) ((53 . 107) (5 . 1) (6 . 2) (4 . 3) (59 . 4) 
    (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) 
    (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) 
    (71 . 20) (72 . 21) (73 . 23) (74 . 28) (33 . 29) (75 . 30) (86 . 108) 
    (64 . 109) (65 . 110)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) 
    (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) 
    (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) 
    (72 . 21) (73 . 23) (74 . 28) (33 . 29) (75 . 30) (86 . 106)) ((1 . -111))
    ((1 . -110)) ((1 . -109)) ((1 . -103)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) 
    (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) 
    (67 . 13) (68 . 105)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) 
    (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) 
    (68 . 104)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) 
    (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (68 . 103)) 
    ((11 . 99) (10 . 100) (51 . 101) (9 . 102) (1 . -99)) ((1 . -90)) (
    (20 . 91) (19 . 92) (18 . 93) (17 . 94) (16 . 95) (15 . 96) (14 . 97) 
    (13 . 98) (1 . -85)) ((24 . 87) (23 . 88) (22 . 89) (21 . 90) (1 . -80)) 
    ((28 . 83) (27 . 84) (26 . 85) (25 . 86) (1 . -77)) ((1 . -138)) ((30 . 81
    ) (29 . 82) (1 . -75)) ((1 . -137)) ((1 . -127)) ((1 . -126)) ((1 . -125))
    ((31 . 80) (1 . -73)) ((1 . -68)) ((33 . 78) (32 . 79) (1 . -67)) (
    (1 . -50)) ((1 . -49)) ((1 . -48)) ((1 . -34)) ((48 . 77)) ((54 . 75) 
    (7 . 6) (91 . 76)) ((7 . 6) (91 . 73) (82 . 74)) ((1 . -46)) ((5 . 1) 
    (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) 
    (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) 
    (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) 
    (33 . 29) (75 . 30) (86 . 72)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) 
    (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13)
    (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) 
    (72 . 21) (73 . 23) (74 . 28) (33 . 29) (75 . 30) (86 . 71)) ((5 . 1) 
    (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) 
    (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) 
    (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) 
    (33 . 29) (75 . 30) (86 . 70)) ((7 . 6) (91 . 69)) ((52 . 68) (1 . -36)) 
    ((1 . -27)) ((3 . 24) (88 . 65) (60 . 66) (93 . 67) (1 . -15)) ((48 . 22) 
    (49 . 25) (8 . 26) (62 . 27) (95 . 64)) ((48 . 22) (3 . 24) (49 . 25) 
    (8 . 26) (62 . 27) (95 . 34) (88 . 35) (89 . 63) (1 . -26)) ((5 . 1) 
    (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) 
    (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) 
    (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) 
    (33 . 29) (75 . 30) (38 . 31) (39 . 32) (40 . 33) (48 . 22) (83 . 37) 
    (41 . 38) (43 . 39) (45 . 40) (46 . 41) (47 . 42) (86 . 43) (49 . 25) 
    (8 . 26) (62 . 27) (87 . 46) (105 . 58) (95 . 59) (98 . 60) (56 . 61) 
    (96 . 62)) ((102 . 55) (104 . 57) (1 . -6)) ((102 . 55) (104 . 56) 
    (1 . -6)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) 
    (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) 
    (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) 
    (73 . 23) (74 . 28) (33 . 29) (75 . 30) (38 . 31) (39 . 32) (40 . 33) 
    (83 . 37) (41 . 38) (43 . 39) (45 . 40) (46 . 41) (47 . 42) (86 . 43) 
    (87 . 46) (105 . 53) (55 . 36) (94 . 45) (99 . 48) (103 . 54)) ((58 . 0)) 
    ((102 . 55) (104 . 168) (1 . -6)) ((102 . 55) (104 . 167) (1 . -6)) 
    ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) 
    (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) 
    (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 23) 
    (74 . 28) (48 . 22) (33 . 29) (75 . 30) (38 . 31) (39 . 32) (40 . 33) 
    (3 . 24) (49 . 25) (8 . 26) (62 . 27) (83 . 37) (41 . 38) (43 . 39) 
    (45 . 40) (46 . 41) (47 . 42) (86 . 43) (55 . 36) (87 . 46) (95 . 34) 
    (88 . 35) (94 . 45) (105 . 160) (89 . 161) (99 . 48) (100 . 164) (103 . 
    165) (101 . 166) (1 . -5)) ((1 . -3)) ((1 . -4)) ((1 . -32)) ((1 . -31)) 
    ((56 . 61) (96 . 159) (5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) 
    (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) 
    (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) 
    (72 . 21) (73 . 23) (74 . 28) (48 . 22) (33 . 29) (75 . 30) (38 . 31) 
    (39 . 32) (40 . 33) (3 . 24) (49 . 25) (8 . 26) (62 . 27) (83 . 37) 
    (41 . 38) (43 . 39) (45 . 40) (46 . 41) (47 . 42) (86 . 43) (87 . 46) 
    (95 . 34) (88 . 35) (105 . 160) (89 . 161) (100 . 162) (97 . 163)) 
    ((48 . 22) (49 . 25) (8 . 26) (62 . 27) (95 . 158)) ((1 . -12)) ((1 . -28)
    ) ((1 . -35)) ((48 . 22) (62 . 157)) ((3 . 24) (88 . 156) (1 . -128)) 
    ((1 . -14)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) 
    (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) 
    (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) 
    (73 . 23) (74 . 28) (33 . 29) (75 . 30) (86 . 155)) ((52 . 154)) ((48 . 22
    ) (49 . 25) (8 . 26) (62 . 27) (95 . 153)) ((48 . 22) (49 . 25) (8 . 26) 
    (62 . 27) (95 . 152)) ((48 . 22) (49 . 25) (8 . 26) (62 . 27) (95 . 151)) 
    ((1 . -51)) ((7 . 6) (91 . 150) (1 . -47)) ((7 . 6) (91 . 148) (92 . 149))
    ((51 . 146) (52 . 147)) ((1 . -33)) ((56 . 144) (5 . 1) (6 . 2) (4 . 3) 
    (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) 
    (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) 
    (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) (75 . 145)) ((5 . 1) 
    (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) 
    (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) 
    (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 143)) 
    ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) 
    (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) 
    (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 142)) 
    ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) 
    (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) 
    (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 141)) ((5 . 1) 
    (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) 
    (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) 
    (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 140)) ((5 . 1) (6 . 2) 
    (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) 
    (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) 
    (69 . 18) (70 . 19) (71 . 139)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5)
    (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13)
    (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 138)) 
    ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) 
    (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) 
    (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 137)) ((5 . 1) (6 . 2) 
    (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) 
    (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) 
    (69 . 18) (70 . 19) (71 . 136)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5)
    (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13)
    (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 135)) ((5 . 1) 
    (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) 
    (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) 
    (68 . 17) (69 . 18) (70 . 134)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5)
    (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13)
    (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 133)) ((5 . 1) 
    (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) 
    (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) 
    (68 . 17) (69 . 18) (70 . 132)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5)
    (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13)
    (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 131)) ((5 . 1) (6 . 2) 
    (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) 
    (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) 
    (69 . 130)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) 
    (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) 
    (24 . 15) (23 . 16) (68 . 17) (69 . 129)) ((5 . 1) (6 . 2) (4 . 3) 
    (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) 
    (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 128)) 
    ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) 
    (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) 
    (23 . 16) (68 . 17) (69 . 127)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5)
    (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13)
    (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 126)) ((5 . 1) (6 . 2) 
    (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) 
    (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) 
    (69 . 125)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) 
    (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) 
    (24 . 15) (23 . 16) (68 . 17) (69 . 124)) ((1 . -104)) ((1 . -105)) 
    ((50 . 121) (5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) 
    (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) 
    (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) 
    (73 . 23) (74 . 28) (33 . 29) (75 . 30) (86 . 122) (76 . 123)) ((7 . 6) 
    (91 . 120)) ((11 . 99) (10 . 100) (51 . 101) (9 . 102) (1 . -100)) 
    ((11 . 99) (10 . 100) (51 . 101) (9 . 102) (1 . -101)) ((11 . 99) (10 . 
    100) (51 . 101) (9 . 102) (1 . -102)) ((50 . 119)) ((1 . -113)) ((1 . -121
    )) ((49 . 118) (1 . -117)) ((53 . 117) (48 . 22) (62 . 114) (8 . 115) 
    (63 . 116)) ((1 . -115)) ((34 . 113) (48 . 22) (62 . 114) (8 . 115) 
    (63 . 116)) ((1 . -116)) ((1 . -120)) ((1 . -119)) ((5 . 1) (6 . 2) 
    (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) 
    (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) 
    (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) (33 . 29) 
    (75 . 30) (86 . 108) (64 . 185)) ((1 . -114)) ((5 . 1) (6 . 2) (4 . 3) 
    (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) 
    (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) 
    (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) (33 . 29) (75 . 30) 
    (86 . 184)) ((1 . -112)) ((1 . -108)) ((1 . -107)) ((1 . -65)) ((50 . 182)
    (49 . 183)) ((1 . -98)) ((1 . -97)) ((1 . -96)) ((1 . -95)) ((1 . -94)) 
    ((1 . -93)) ((1 . -92)) ((1 . -91)) ((20 . 91) (19 . 92) (18 . 93) 
    (17 . 94) (16 . 95) (15 . 96) (14 . 97) (13 . 98) (1 . -89)) ((20 . 91) 
    (19 . 92) (18 . 93) (17 . 94) (16 . 95) (15 . 96) (14 . 97) (13 . 98) 
    (1 . -88)) ((20 . 91) (19 . 92) (18 . 93) (17 . 94) (16 . 95) (15 . 96) 
    (14 . 97) (13 . 98) (1 . -87)) ((20 . 91) (19 . 92) (18 . 93) (17 . 94) 
    (16 . 95) (15 . 96) (14 . 97) (13 . 98) (1 . -86)) ((24 . 87) (23 . 88) 
    (22 . 89) (21 . 90) (1 . -84)) ((24 . 87) (23 . 88) (22 . 89) (21 . 90) 
    (1 . -83)) ((24 . 87) (23 . 88) (22 . 89) (21 . 90) (1 . -82)) ((24 . 87) 
    (23 . 88) (22 . 89) (21 . 90) (1 . -81)) ((28 . 83) (27 . 84) (26 . 85) 
    (25 . 86) (1 . -79)) ((28 . 83) (27 . 84) (26 . 85) (25 . 86) (1 . -78)) 
    ((30 . 81) (29 . 82) (1 . -76)) ((31 . 80) (1 . -74)) ((1 . -71)) (
    (32 . 79) (33 . 181) (1 . -69)) ((7 . 6) (91 . 148) (92 . 179) (50 . 180))
    ((7 . 6) (91 . 178)) ((1 . -22)) ((49 . 176) (53 . 177)) ((1 . -52)) 
    ((84 . 175) (1 . -55)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) 
    (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) 
    (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) 
    (72 . 21) (73 . 23) (74 . 28) (48 . 22) (33 . 29) (75 . 30) (38 . 31) 
    (39 . 32) (40 . 33) (3 . 24) (49 . 25) (8 . 26) (62 . 27) (83 . 37) 
    (41 . 38) (43 . 39) (45 . 40) (46 . 41) (47 . 42) (86 . 43) (87 . 46) 
    (95 . 34) (88 . 35) (105 . 160) (89 . 161) (100 . 162) (97 . 174)) 
    ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) 
    (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) 
    (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 23) 
    (74 . 28) (48 . 22) (33 . 29) (75 . 30) (38 . 31) (39 . 32) (40 . 33) 
    (3 . 24) (49 . 25) (8 . 26) (62 . 27) (83 . 37) (41 . 38) (43 . 39) 
    (45 . 40) (46 . 41) (47 . 42) (86 . 43) (87 . 46) (95 . 34) (88 . 35) 
    (105 . 160) (89 . 161) (100 . 162) (97 . 173)) ((5 . 1) (6 . 2) (4 . 3) 
    (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) 
    (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) 
    (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) (33 . 29) (75 . 30) 
    (86 . 172)) ((1 . -37)) ((48 . 22) (62 . 171)) ((1 . -129)) ((1 . -13)) 
    ((1 . -11)) ((1 . -30)) ((1 . -29)) ((1 . -24)) ((56 . 61) (96 . 169) 
    (5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) 
    (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) 
    (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 23) 
    (74 . 28) (48 . 22) (33 . 29) (75 . 30) (38 . 31) (39 . 32) (40 . 33) 
    (3 . 24) (49 . 25) (8 . 26) (62 . 27) (83 . 37) (41 . 38) (43 . 39) 
    (45 . 40) (46 . 41) (47 . 42) (86 . 43) (87 . 46) (95 . 34) (88 . 35) 
    (105 . 160) (89 . 161) (100 . 170)) ((1 . -9)) ((1 . -8)) ((1 . -7)) 
    ((1 . -2)) ((1 . -1)) ((1 . -10)) ((1 . -25)) ((1 . -130)) ((48 . 22) 
    (49 . 25) (8 . 26) (62 . 27) (95 . 202)) ((56 . 201) (5 . 1) (6 . 2) 
    (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) 
    (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) 
    (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) (48 . 22) 
    (33 . 29) (75 . 30) (38 . 31) (39 . 32) (40 . 33) (3 . 24) (49 . 25) 
    (8 . 26) (62 . 27) (83 . 37) (41 . 38) (43 . 39) (45 . 40) (46 . 41) 
    (47 . 42) (86 . 43) (87 . 46) (95 . 34) (88 . 35) (105 . 160) (89 . 161) 
    (100 . 170)) ((56 . 197) (5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) 
    (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13)
    (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) 
    (72 . 21) (73 . 23) (74 . 28) (48 . 22) (33 . 29) (75 . 30) (38 . 31) 
    (39 . 32) (40 . 33) (3 . 24) (49 . 25) (8 . 26) (62 . 27) (83 . 37) 
    (41 . 38) (43 . 39) (45 . 40) (46 . 41) (47 . 42) (86 . 43) (87 . 46) 
    (95 . 34) (88 . 35) (105 . 160) (89 . 161) (100 . 170) (44 . 198) (37 . 
    199) (85 . 200)) ((56 . 194) (36 . 195) (42 . 196)) ((7 . 6) (91 . 193)) 
    ((52 . 192)) ((51 . 191)) ((50 . 190) (49 . 176)) ((48 . 22) (49 . 25) 
    (8 . 26) (62 . 27) (95 . 189)) ((56 . 187) (5 . 1) (6 . 2) (4 . 3) 
    (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) 
    (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) 
    (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) (75 . 188)) ((1 . -106))
    ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) 
    (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) 
    (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 23) 
    (74 . 28) (33 . 29) (75 . 30) (86 . 186)) ((1 . -122)) ((49 . 118) 
    (1 . -118)) ((1 . -66)) ((1 . -72)) ((32 . 79) (1 . -70)) ((1 . -21)) 
    ((48 . 22) (49 . 25) (8 . 26) (62 . 27) (95 . 217)) ((7 . 6) (91 . 148) 
    (92 . 215) (50 . 216)) ((7 . 6) (91 . 214)) ((1 . -23)) ((1 . -45)) 
    ((4 . 3) (6 . 2) (35 . 210) (79 . 211) (80 . 212) (81 . 213)) ((48 . 22) 
    (49 . 25) (8 . 26) (62 . 27) (95 . 209)) ((1 . -43)) ((5 . 1) (6 . 2) 
    (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) 
    (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) 
    (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) (48 . 22) 
    (33 . 29) (75 . 30) (38 . 31) (39 . 32) (40 . 33) (3 . 24) (49 . 25) 
    (8 . 26) (62 . 27) (83 . 37) (41 . 38) (43 . 39) (45 . 40) (46 . 41) 
    (47 . 42) (86 . 43) (87 . 46) (95 . 34) (88 . 35) (105 . 160) (89 . 161) 
    (100 . 162) (97 . 208)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) 
    (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13)
    (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) 
    (72 . 21) (73 . 23) (74 . 28) (33 . 29) (75 . 30) (86 . 207)) ((44 . 204) 
    (37 . 205) (56 . 206)) ((1 . -39)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) 
    (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) 
    (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) 
    (71 . 20) (72 . 21) (73 . 23) (74 . 28) (48 . 22) (33 . 29) (75 . 30) 
    (38 . 31) (39 . 32) (40 . 33) (3 . 24) (49 . 25) (8 . 26) (62 . 27) 
    (83 . 37) (41 . 38) (43 . 39) (45 . 40) (46 . 41) (47 . 42) (86 . 43) 
    (87 . 46) (95 . 34) (88 . 35) (105 . 160) (89 . 161) (100 . 162) (97 . 203
    )) ((56 . 231) (5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) 
    (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) 
    (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) 
    (73 . 23) (74 . 28) (48 . 22) (33 . 29) (75 . 30) (38 . 31) (39 . 32) 
    (40 . 33) (3 . 24) (49 . 25) (8 . 26) (62 . 27) (83 . 37) (41 . 38) 
    (43 . 39) (45 . 40) (46 . 41) (47 . 42) (86 . 43) (87 . 46) (95 . 34) 
    (88 . 35) (105 . 160) (89 . 161) (100 . 170)) ((5 . 1) (6 . 2) (4 . 3) 
    (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) 
    (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) 
    (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) (48 . 22) (33 . 29) 
    (75 . 30) (38 . 31) (39 . 32) (40 . 33) (3 . 24) (49 . 25) (8 . 26) 
    (62 . 27) (83 . 37) (41 . 38) (43 . 39) (45 . 40) (46 . 41) (47 . 42) 
    (86 . 43) (87 . 46) (95 . 34) (88 . 35) (105 . 160) (89 . 161) (100 . 162)
    (97 . 230)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) 
    (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) 
    (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) 
    (73 . 23) (74 . 28) (33 . 29) (75 . 30) (86 . 229)) ((1 . -41)) ((48 . 22)
    (49 . 25) (8 . 26) (62 . 27) (95 . 228)) ((56 . 227) (5 . 1) (6 . 2) 
    (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) 
    (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) 
    (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) (48 . 22) 
    (33 . 29) (75 . 30) (38 . 31) (39 . 32) (40 . 33) (3 . 24) (49 . 25) 
    (8 . 26) (62 . 27) (83 . 37) (41 . 38) (43 . 39) (45 . 40) (46 . 41) 
    (47 . 42) (86 . 43) (87 . 46) (95 . 34) (88 . 35) (105 . 160) (89 . 161) 
    (100 . 170)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) 
    (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) 
    (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) 
    (73 . 23) (74 . 28) (48 . 22) (33 . 29) (75 . 30) (38 . 31) (39 . 32) 
    (40 . 33) (3 . 24) (49 . 25) (8 . 26) (62 . 27) (83 . 37) (41 . 38) 
    (43 . 39) (45 . 40) (46 . 41) (47 . 42) (86 . 43) (87 . 46) (95 . 34) 
    (88 . 35) (105 . 160) (89 . 161) (100 . 162) (97 . 226)) ((6 . 2) (80 . 
    222) (78 . 223) (4 . 3) (79 . 224) (77 . 225)) ((1 . -58)) ((1 . -57)) 
    ((48 . 22) (49 . 25) (8 . 26) (62 . 27) (95 . 221)) ((51 . 220)) ((50 . 
    219) (49 . 176)) ((48 . 22) (49 . 25) (8 . 26) (62 . 27) (95 . 218)) 
    ((1 . -20)) ((1 . -19)) ((48 . 22) (49 . 25) (8 . 26) (62 . 27) (95 . 243)
    ) ((7 . 6) (91 . 148) (92 . 241) (50 . 242)) ((5 . 1) (6 . 2) (4 . 3) 
    (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) 
    (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) 
    (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) (48 . 22) (33 . 29) 
    (75 . 30) (38 . 31) (39 . 32) (40 . 33) (3 . 24) (49 . 25) (8 . 26) 
    (62 . 27) (83 . 37) (41 . 38) (43 . 39) (45 . 40) (46 . 41) (47 . 42) 
    (86 . 43) (87 . 46) (95 . 34) (88 . 35) (105 . 160) (89 . 161) (100 . 162)
    (97 . 240)) ((1 . -61)) ((34 . 238) (6 . 2) (80 . 239)) ((1 . -63)) 
    ((34 . 236) (4 . 3) (79 . 237)) ((56 . 235) (5 . 1) (6 . 2) (4 . 3) 
    (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) 
    (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) 
    (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) (48 . 22) (33 . 29) 
    (75 . 30) (38 . 31) (39 . 32) (40 . 33) (3 . 24) (49 . 25) (8 . 26) 
    (62 . 27) (83 . 37) (41 . 38) (43 . 39) (45 . 40) (46 . 41) (47 . 42) 
    (86 . 43) (87 . 46) (95 . 34) (88 . 35) (105 . 160) (89 . 161) (100 . 170)
    ) ((1 . -42)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) 
    (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) 
    (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) 
    (73 . 23) (74 . 28) (48 . 22) (33 . 29) (75 . 30) (38 . 31) (39 . 32) 
    (40 . 33) (3 . 24) (49 . 25) (8 . 26) (62 . 27) (83 . 37) (41 . 38) 
    (43 . 39) (45 . 40) (46 . 41) (47 . 42) (86 . 43) (87 . 46) (95 . 34) 
    (88 . 35) (105 . 160) (89 . 161) (100 . 162) (97 . 234)) ((48 . 22) 
    (49 . 25) (8 . 26) (62 . 27) (95 . 233)) ((56 . 232) (5 . 1) (6 . 2) 
    (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) 
    (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) 
    (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 23) (74 . 28) (48 . 22) 
    (33 . 29) (75 . 30) (38 . 31) (39 . 32) (40 . 33) (3 . 24) (49 . 25) 
    (8 . 26) (62 . 27) (83 . 37) (41 . 38) (43 . 39) (45 . 40) (46 . 41) 
    (47 . 42) (86 . 43) (87 . 46) (95 . 34) (88 . 35) (105 . 160) (89 . 161) 
    (100 . 170)) ((1 . -38)) ((1 . -40)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) 
    (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) 
    (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) 
    (71 . 20) (72 . 21) (73 . 23) (74 . 28) (48 . 22) (33 . 29) (75 . 30) 
    (38 . 31) (39 . 32) (40 . 33) (3 . 24) (49 . 25) (8 . 26) (62 . 27) 
    (83 . 37) (41 . 38) (43 . 39) (45 . 40) (46 . 41) (47 . 42) (86 . 43) 
    (87 . 46) (95 . 34) (88 . 35) (105 . 160) (89 . 161) (100 . 162) (97 . 246
    )) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) (54 . 8) 
    (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) (24 . 15) 
    (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) (73 . 23) 
    (74 . 28) (48 . 22) (33 . 29) (75 . 30) (38 . 31) (39 . 32) (40 . 33) 
    (3 . 24) (49 . 25) (8 . 26) (62 . 27) (83 . 37) (41 . 38) (43 . 39) 
    (45 . 40) (46 . 41) (47 . 42) (86 . 43) (87 . 46) (95 . 34) (88 . 35) 
    (105 . 160) (89 . 161) (100 . 170) (1 . -53)) ((1 . -44)) ((1 . -60)) 
    ((1 . -64)) ((1 . -59)) ((1 . -62)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) 
    (80 . 5) (7 . 6) (35 . 7) (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) 
    (67 . 13) (12 . 14) (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) 
    (71 . 20) (72 . 21) (73 . 23) (74 . 28) (48 . 22) (33 . 29) (75 . 30) 
    (38 . 31) (39 . 32) (40 . 33) (3 . 24) (49 . 25) (8 . 26) (62 . 27) 
    (83 . 37) (41 . 38) (43 . 39) (45 . 40) (46 . 41) (47 . 42) (86 . 43) 
    (87 . 46) (95 . 34) (88 . 35) (105 . 160) (89 . 161) (100 . 170) (1 . -56)
    ) ((50 . 245) (49 . 176)) ((48 . 22) (49 . 25) (8 . 26) (62 . 27) (95 . 
    244)) ((1 . -18)) ((1 . -17)) ((48 . 22) (49 . 25) (8 . 26) (62 . 27) 
    (95 . 247)) ((5 . 1) (6 . 2) (4 . 3) (59 . 4) (80 . 5) (7 . 6) (35 . 7) 
    (54 . 8) (51 . 9) (79 . 10) (66 . 11) (91 . 12) (67 . 13) (12 . 14) 
    (24 . 15) (23 . 16) (68 . 17) (69 . 18) (70 . 19) (71 . 20) (72 . 21) 
    (73 . 23) (74 . 28) (48 . 22) (33 . 29) (75 . 30) (38 . 31) (39 . 32) 
    (40 . 33) (3 . 24) (49 . 25) (8 . 26) (62 . 27) (83 . 37) (41 . 38) 
    (43 . 39) (45 . 40) (46 . 41) (47 . 42) (86 . 43) (87 . 46) (95 . 34) 
    (88 . 35) (105 . 160) (89 . 161) (100 . 170) (1 . -54)) ((1 . -16))))

(define mlang-tables
  (list
   (cons 'mtab mlang-mtab)
   (cons 'ntab mlang-ntab)
   (cons 'len-v mlang-len-v)
   (cons 'rto-v mlang-rto-v)
   (cons 'pat-v mlang-pat-v)
   ))

;;; end tables
